﻿/////////////////////////////////////////////////
/// data section
/////////////////////////////////////////////////


Ha.Data = Ha.Data || {};

// groups configuration
Ha.Data.Groups = Array();

// last module data
Ha.Data.Modules = Array();


// automation groups configuration
Ha.Data.AutomationGroups = Array();

Ha.Data.AutomationProgram = null;


// /Control/Module/
Ha.Data.ServiceCall = function (fn, postdata, method, callback) {
    var url = '/Api/EasyIoT/' + fn + '/';
    $.ajax({
        url: url,
        type: method,
        data: postdata,
        dataType: "json",
        success: function (data) {
            var value = eval(data);
            if (typeof value == 'undefined') {
                value = data;
            }
            else if (typeof value[0] != 'undefined' && typeof value[0].ResponseValue  != 'undefined') {
                try {
                    value = value[0].ResponseValue;
                } catch (e) { value = data; }
            }
            if (callback != null) callback(value);
            //callback(value);
        },
        error: function (a, b, c) {
            //$.mobile.hidePageLoadingMsg();
            alert('Error ' + url);
        }
    });
};



////////////////////////////////////////
// Ha.Data.Driver
////////////////////////////////////////
Ha.Data.Driver = Ha.Data.Driver || {};

////////////////////////////////////////
// Ha.Data.Group
////////////////////////////////////////
Ha.Data.Group = Ha.Data.Group || {};

Ha.Data.Group.GetModuleGroup = function (module) {
    var group = null;
    for (var i = 0; i < Ha.Data.Groups.length; i++) {
        for (var j = 0; j < Ha.Data.Groups[i].Modules.length; j++) {
            if (module.Domain == Ha.Data.Groups[i].Modules[j].Domain && module.Address == Ha.Data.Groups[i].Modules[j].Address) {
                group = Ha.Data.Groups[i];
                break;
            }
        }
        if (group != null) break;
    }
    return group;
};


////////////////////////////////////////
// Ha.Data.Module
////////////////////////////////////////
Ha.Data.Module = Ha.Data.Module || {};

// remove module from group
Ha.Data.Module.RemoveFromGroup = function (groupname, domain, address, callback) {
    for (i = 0; i < Ha.Data.Groups.length; i++) {
        if (Ha.Data.Groups[i].GroupName == groupname) {
            Ha.Data.Groups[i].Modules = $.grep(Ha.Data.Groups[i].Modules, function (value) {
                return value.Domain != domain || value.Address != address;
            });
            break;
        }
    }

    //Ha.Data.Group.ServiceCall1("SaveAll", JSON.stringify(Ha.Data.Groups), "POST", callback);
    Ha.Data.ServiceCall("Config/Group/SaveAll/", JSON.stringify(Ha.Data.Groups), "POST", callback);
    //Ha.Data.Group.SaveAll(callback);
};

// filter group module list
Ha.Data.Module.ListGroupModules = function (groupname) {
    var groupmodules = { 'Modules': Array() };
    for (var i = 0; i < Ha.Data.Groups.length; i++) {
        if (Ha.Data.Groups[i].GroupName == groupname) {
            for (var j = 0; j < Ha.Data.Groups[i].Modules.length; j++) {
                for (var k = 0; k < Ha.Data.Modules.length; k++) {
                    if ((Ha.Data.Groups[i].Modules[j].Domain == Ha.Data.Modules[k].Domain) && (Ha.Data.Groups[i].Modules[j].Address == Ha.Data.Modules[k].Address)) {
                        groupmodules.Modules.push(Ha.Data.Modules[k]);
                    }
                }
            }
        }
    }
    return groupmodules;
};


Ha.Data.Module.GetModuleByDomainAddress = function (domain, address) {
    var module = null;
    for (var i = 0; i < Ha.Data.Modules.length; i++) {
        if (Ha.Data.Modules[i].Domain == domain && Ha.Data.Modules[i].Address == address) {
            module = Ha.Data.Modules[i];
            break;
        }
    }
    return module;
}