﻿/////////////////////////////////////////////////
/// Utility section
/////////////////////////////////////////////////

Ha.WebApp.Utility = Ha.WebApp.Utility || {};


Ha.WebApp.Utility.OpenSubPopUp= function(popup1, popup2){

    var openPopup = function (event, ui) {
        setTimeout(function () { $(popup2).popup('open', { transition: 'pop' }); }, 100);
        $(popup1).off('popupafterclose', openPopup);
    };

    $(popup1).on('popupafterclose', openPopup);
    $(popup1).popup("close");
}


Ha.WebApp.Utility.GetModulePropertyByName = function (module, prop) {
    var value = null;
    if (module.Properties != null) {
        for (var p = 0; p < module.Properties.length; p++) {
            if (module.Properties[p].Name == prop) {
                value = module.Properties[p];
                break;
            }
        }
    }
    return value;
};


Ha.WebApp.Utility.SetModulePropertyByName = function (module, prop, value, timestamp) {
    var found = false;
    if (module.Properties != null) {
        for (var p = 0; p < module.Properties.length; p++) {
            if (module.Properties[p].Name == prop) {
                //module.Properties[p].LastValue = module.Properties[p].Value;
                module.Properties[p].Value = value;
                if (typeof timestamp != 'undefined') {
                    module.Properties[p].UpdateTime = timestamp;
                }
                found = true;
                break;
            }
        }
        if (!found) {
            module.Properties.push({ 'Name': prop, 'Value': value });
        }
    }
};


Ha.WebApp.Utility.FormatDate = function (date) {
    var dt = $.datepicker.formatDate('D, dd/mm/yy', date);
    return dt;
};

Ha.WebApp.Utility.FormatDateTime = function (date, showms) {
    var hh = date.getHours().toString(); if (hh.length == 1) hh = '0' + hh;
    var mm = date.getMinutes().toString(); if (mm.length == 1) mm = '0' + mm;
    var ss = date.getSeconds().toString(); if (ss.length == 1) ss = '0' + ss;
    var dt = hh + ':' + mm + ':' + ss;
    if (showms) dt += '.' + date.getMilliseconds();
    return dt;
};
