﻿var Ha = Ha || {};

{include js/Ha.Data.js}
// WebApp
Ha.WebApp = Ha.WebApp || {};

{include js/Ha.WebApp.Utility.js}
{include js/Ha.WebApp.Control.js}
{include js/Ha.WebApp.Configure.js}
{include js/Ha.WebApp.Events.js}


// Main App
Ha.WebApp = Ha.WebApp || {};

Ha.WebApp.InitializePage = function () {
    $.ajaxSetup({ cache: false });
    $.mobile.ajaxFormsEnabled = false;

    // one time init
    Ha.WebApp.Configure.InitPage();
    Ha.WebApp.Events.InitializePage();
    
    Ha.WebApp.Control.ReloadPage();

    $('[data-role=page]').on('pagebeforeshow', function (event) {
        if (this.id == "page_config") {        
        }
        else if (this.id == "page_groupmodules_groups") {
            Ha.WebApp.Configure.ReloadGroups();
        }
        else if (this.id == "page_groupmodules_groupmodules") {
            Ha.WebApp.Configure.ReloadModules();
        }
        else if (this.id == "page_config_drivers_mysensors") {
            Ha.WebApp.Configure.InitMySensorsDriver();
        }
        else if (this.id == "page_config_drivers") {
            //Ha.WebApp.Configure.InitNRF24LDriver();
        }
        else if (this.id == "page_config_drivers_mysensors") {
            Ha.WebApp.Configure.InitMySensorsDriver();
        }
        else if (this.id == "page_config_drivers_rpigpio") {
            Ha.WebApp.Configure.InitRPiGPIODriver();
        }
        else if (this.id == "page_config_drivers_esp8266easyiot") {
            Ha.WebApp.Configure.InitEsp8266EasyIoTDriver();
        }
        else if (this.id == "page_control") {
            Ha.WebApp.Control.ReloadPage();
        }
        else if (this.id == "page_config_webinterface") {
            Ha.WebApp.Configure.InitWebinterface();
        }
        else if (this.id == "page_config_smsinterface") {
            Ha.WebApp.Configure.InitSmsinterface();
        }
        else if (this.id == "page_automation_automationgroups") {
            Ha.WebApp.Configure.InitAutomationGroups();
        }
        else if (this.id == "page_automation_automationlist") {
            Ha.WebApp.Configure.InitAutomationList();
        }
        else if (this.id == "page_automation_automationprogramparam") {
            Ha.WebApp.Configure.InitProgramParam();
        }
        else if (this.id == "page_automation_automationprogram") {
            Ha.WebApp.Configure.InitProgram();
        }
        else if (this.id == "page_config_generalsettings") {
            Ha.WebApp.Configure.InitGeneralSettings();
        }
        else if (this.id == "page_control_chart") {   
            Ha.WebApp.Control.InitChart(); 
        }
    });
}
